#ifndef ZLS_UTIL_H
#define ZLS_UTIL_H

#include "zls_types.h"
#include "zls_qs.h"
#include "gsl_spline.h"

int zls_LogXConvolve(Q1DArr wv, Q1DArr fl, Q1DArr cn, Q1DArr nz, Counter nSpec, Real resR, Real fwhm, Real vSini, Real box );

    // These are width convolutions, in whichever x space called with. Widths need to
    // be computed in log or linear space as appropriate, usually by a driver routine
    // rather than calling directly.

int zls_RotationalConvolution  ( Q1DArr lwv, Q1DArr fl, Counter n, Real sigma);
int zls_GaussianConvolution    ( Q1DArr lwv, Q1DArr fl, Counter n, Real sigma);
int zls_BoxcarConvolution      ( Q1DArr lwv, Q1DArr fl, Counter n, Real sigma);

    // Actual convolution once normalised response array is constructed

int zls_DirectConvolution      ( Q1DArr f, Q1DArr resp, Counter n, Counter nResp);

#endif
